import { _decorator, Component, Label, Node, RichText, Sprite, UITransform } from 'cc';
const { ccclass, property } = _decorator;

@ccclass('ChatItemRender')
export class ChatItemRender extends Component {
	@property(Label)
	protected txtTimer: Label;

	@property(Label)
	protected txtLeftID: Label;

	@property(Sprite)
	protected skinLQuality: Sprite;

	@property(Sprite)
	protected skinLIcon: Sprite;

	@property(Sprite)
	protected skinLKuang: Sprite;

	@property(Node)
	protected nodeL: Node;

	@property(RichText)
	protected richLeft: RichText;

	@property(Sprite)
	protected chatLbg: Sprite;

	@property(Node)
	protected nodeLeft: Node;

	@property(Label)
	protected txtRightID: Label;

	@property(Sprite)
	protected skinRQuality: Sprite;

	@property(Sprite)
	protected skinRIcon: Sprite;

	@property(Sprite)
	protected skinRKuang: Sprite;

	@property(Node)
	protected nodeR: Node;

	@property(RichText)
	protected richRight: RichText;

	@property(Sprite)
	protected chatRbg: Sprite;

	@property(Node)
	protected nodeRight: Node;

	private data: string;

	set(data: string, left: boolean) {
		this.data = data;
		if (left) {
			this.nodeLeft.active = true;
			this.nodeRight.active = false;
			this.showLeft();
		}
		else {
			this.nodeLeft.active = false;
			this.nodeRight.active = true;
			this.showRight();
		}
	}

	private showLeft() {
		this.txtLeftID.string = `左边`;
		this.richLeft.string = `${this.data}`;
		this.setChatSize(this.richLeft, this.chatLbg.node);
	}

	private showRight() {
		this.txtRightID.string = `右边`;
		this.richRight.string = `${this.data}`;
		this.setChatSize(this.richRight, this.chatRbg.node);
	}


	/**
	 * 聊天大小
	 * @param txt 
	 * @param chatbg 
	 */
	private setChatSize(txt: RichText, chatbg: Node) {
		this.scheduleOnce(
			() => {
				const widths: number[] = txt["_linesWidth"];
				let width: number = 0;
				if (widths && widths.length > 0) {
					width = Math.max(...widths);
				}
				if (width < 320) {
					width += 30;
					let height2 = chatbg.getComponent(UITransform).height;
					chatbg.getComponent(UITransform).setContentSize(width, height2);
				} else {
					width = 400;
					let height3 = chatbg.getComponent(UITransform).height;
					chatbg.getComponent(UITransform).setContentSize(width, height3);
				}
			});
	}

	update(deltaTime: number) {

	}
}


