import { _decorator, Component, instantiate, Node, profiler } from 'cc';
import ScroView from '../scro/ScroView';
import { ChatItemRender } from './ChatItemRender';
const { ccclass, property } = _decorator;

@ccclass('ChatView')
export class ChatView extends Component {
    @property(ScroView)
    protected scroView: ScroView;

    private chat: string[] = [
        `欢迎使用 Cocos Creator 3.8！`,
        `Cocos Creator 既是一款高效、轻量、免费开源的跨平台 2D&3D 图形引擎，也是一个实时 2D&3D 数字内容创作平台`,
        `拥有 高性能、低功耗、流式加载、跨平台 等诸多优点，您可以用它来创作 游戏、车机、XR、元宇宙 等领域的项目`,
        `3.8 新增功能`,
        `完整的更新列表请前往`,
        `用户手册主要模块`,
        `场景制作`,
        `脚本指南及事件系统`,
        `发布跨平台游戏`,
        `图形渲染`,
        `扩展编辑器`,
        `可以提问、查找问题答案、与其他开发者交流`,
        `可以获得教程和官方示例项目`,
        `可以获得更多素材、学习案例以及源码`,
        `发布于 2021 年初，是当前 Cocos Creator 的最新版本`,
        `发布于 2018 年，2023 年停止更新`,
        `当 Cocos 作为引擎的名字单独出现时，通常代表 Cocos Creator 3.x`,
        `采用全新高性能跨平台 3D 内核`,
        `标志着 Cocos Creator 正式发展为全面的泛移动端 3D 游戏引擎`
    ]

    protected onLoad(): void {
        profiler.showStats();
    }

    start() {
    }

    update(deltaTime: number) {

    }

    protected onEnable(): void {
        this.scheduleOnce(
            () => {
                this.show();
            }, 0.5);
    }

    private show() {
        let content = this.scroView.content;
        let iRender = content.children[0];

        this.hideALL(content);
        for (let i = 0; i < this.chat.length; i++) {
            let msg = this.chat[i];

            let itemRender = content.children[i] ?? instantiate(iRender);
            itemRender.active = true;
            content.addChild(itemRender);

            let left: boolean = Math.random() > 0.5 ? true : false;
            itemRender.getComponent(ChatItemRender).set(msg, left);
        }
    }

    private hideALL(parent: Node) {
        if (!parent)
            return console.error("传参错误！");

        let children = parent.children;
        children.forEach(
            (v) => {
                v.active = false;
            });
    }
}


